// WL_AGENT.C

#include "wl_def.h"
#pragma hdrstop

extern	statetype s_rocket;
extern  statetype s_fire1;
extern  statetype s_beamobj1;

/*
=============================================================================

                                LOCAL CONSTANTS

=============================================================================
*/

#define MAXMOUSETURN    10


#define MOVESCALE       150l
#define BACKMOVESCALE   100l
#define ANGLESCALE      20

/*
=============================================================================

                                GLOBAL VARIABLES

=============================================================================
*/



//
// player state info
//
int32_t         thrustspeed;

word            plux,pluy;          // player coordinates scaled to unsigned

short           anglefrac;

short			gotmlauncher,gotflamethrower,gotlightning;
short			extraammo,eextraammo,eeextraammo;

objtype        *LastAttacker;

/*
=============================================================================

                                                 LOCAL VARIABLES

=============================================================================
*/


void    T_Player (objtype *ob);
void    T_Attack (objtype *ob);

statetype   s_player = {false,0,0,(statefunc) T_Player,NULL,NULL};
statetype   s_attack = {false,0,0,(statefunc) T_Attack,NULL,NULL};

struct atkinf
{
    int8_t    tics,attack,frame;              // attack is 1 for gun, 2 for knife
} attackinfo[10][14] =
{
{ {6,0,1},{6,2,2},{6,0,3},{6,-1,4} },		// Knife
{ {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },		// Pistol
{ {6,0,1},{6,1,2},{6,3,3},{6,-1,4} },		// Machine Gun
{ {6,0,1},{6,1,2},{6,4,3},{6,-1,4} },		// Chaingun
{ {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },		// Mauser
{ {6,0,1},{6,1,2},{6,3,3},{6,-1,4} },		// STG44
{ {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },		// Silenced Sten
{ {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },		// Missile Launcher
{ {6,0,1},{6,1,2},{6,3,3},{6,-1,4} },		// Flamethrower
{ {6,0,1},{6,1,2},{6,3,3},{6,-1,4} },		// Lightning Gun
};

//===========================================================================

//----------

void Attack (void);
void Use (void);
void Search (objtype *ob);
void SelectWeapon (void);
void SelectItem (void);

//----------

boolean TryMove (objtype *ob);
void T_Player (objtype *ob);

void ClipMove (objtype *ob, int32_t xmove, int32_t ymove);

/*
=============================================================================

                                CONTROL STUFF

=============================================================================
*/

// Checks to make sure you have ammo for weapon 
// returns "true" if yes and "false" if no 
int ChkAtkAmmo (int weapon)
{ 
   switch (weapon) 
   {    
      case wp_knife:  
           return 1; 						
      case wp_pistol: 
           if (gamestate.ammo > 0) return 1; 
         break; 
      case wp_machinegun: 
           if (gamestate.gotmachinegun && gamestate.ammo > 0) return 1; 
         break; 
      case wp_rifle1: 
           if (gamestate.gotrifle1 && gamestate.ammo > 0) return 1; 
         break; 
      case wp_rifle2: 
           if (gamestate.gotrifle2 && gamestate.ammo > 0) return 1; 
         break;
      case wp_chaingun: 
           if (gamestate.ammo > 0) return 1; 
         break; 
   	  case wp_mlauncher: 
           if (gotmlauncher && gamestate.missile > 0) return 1; 
         break;    
	  case wp_ft: 
           if (gotflamethrower && gamestate.oil > 0) return 1; 
         break; 
      case wp_lightning: 
           if (gotlightning && gamestate.batteries > 0) return 1; 
         break;  
      case wp_stengun: 
           if (gamestate.gotstengun && gamestate.ammo > 0) return 1; 
         break;          		   
   } 
   return 0; 
} 

/*
======================
=
= CheckWeaponChange
=
= Keys 1-0 change weapons
=
======================
*/

void CheckWeaponChange (void)
{
    int	i,buttons;

    	if (Keyboard[sc_X]) 				// Crosshair
    	{
		if (gamestate.crosshair == 0)
		{
			gamestate.crosshair = 1;
		}
		else
		{
			gamestate.crosshair = 0;
		}
	}

    if (Keyboard[sc_7] && gotmlauncher && gamestate.missile > 0) {
		gamestate.chosenweapon = gamestate.weapon = wp_mlauncher;
		if (!extraammo) 
			extraammo = 1;
		DrawAmmo();
		return;
     	}

    if (Keyboard[sc_8] && gotflamethrower && gamestate.oil > 0) {
		gamestate.chosenweapon = gamestate.weapon = wp_ft;
		if (!eextraammo) 
			eextraammo = 1;
		DrawAmmo();
		return;
     	}

    if (Keyboard[sc_9] && gotlightning && gamestate.batteries > 0) {
		gamestate.chosenweapon = gamestate.weapon = wp_lightning;
		if (!eeextraammo) 
			eeextraammo = 1;
		DrawAmmo();
		return;
     	}
    
    if (Keyboard[sc_1] && gamestate.weapon == wp_knife ||
        Keyboard[sc_2] && gamestate.weapon == wp_pistol ||
       	Keyboard[sc_3] && gamestate.weapon == wp_machinegun ||
    	Keyboard[sc_4] && gamestate.weapon == wp_rifle1 && gamestate.gotrifle1 ||
       	Keyboard[sc_5] && gamestate.weapon == wp_rifle2 && gamestate.gotrifle2 ||
    	Keyboard[sc_6] && gamestate.weapon == wp_chaingun ||
        Keyboard[sc_0] && gamestate.weapon == wp_stengun && gamestate.gotstengun)
        if (extraammo)
			extraammo = 0;

//    if (!gamestate.ammo)		// must use knife with no ammo
//		gamestate.weapon = gamestate.bestweapon = wp_knife;

    if (!gamestate.ammo && !gamestate.missile && !gamestate.oil && !gamestate.batteries)	
       gamestate.weapon = wp_knife;
    if (Keyboard[sc_1] && gamestate.bestweapon >= wp_knife)
        gamestate.weapon = gamestate.chosenweapon = wp_knife;
    else if (Keyboard[sc_2] && gamestate.bestweapon >= wp_pistol)
        gamestate.weapon = gamestate.chosenweapon = wp_pistol;
    else if (Keyboard[sc_3] && gamestate.bestweapon >= wp_machinegun)
        gamestate.weapon = gamestate.chosenweapon = wp_machinegun;
    else if (Keyboard[sc_4] && gamestate.bestweapon >= wp_rifle1 && gamestate.gotrifle1)
        gamestate.weapon = gamestate.chosenweapon = wp_rifle1;
    else if (Keyboard[sc_5] && gamestate.bestweapon >= wp_rifle2 && gamestate.gotrifle2)
        gamestate.weapon = gamestate.chosenweapon = wp_rifle2;
    else if (Keyboard[sc_6] && gamestate.bestweapon >= wp_chaingun)
        gamestate.weapon = gamestate.chosenweapon = wp_chaingun;        
    else if (Keyboard[sc_7] && gamestate.bestweapon >= wp_mlauncher && gotmlauncher)
        gamestate.weapon = gamestate.chosenweapon = wp_mlauncher;
    else if (Keyboard[sc_8] && gamestate.bestweapon >= wp_ft && gotflamethrower)
        gamestate.weapon = gamestate.chosenweapon = wp_ft;
    else if (Keyboard[sc_9] && gamestate.bestweapon >= wp_lightning && gotlightning)
        gamestate.weapon = gamestate.chosenweapon = wp_lightning;    
    else if (Keyboard[sc_0] && gamestate.bestweapon >= wp_stengun && gamestate.gotstengun)
        gamestate.weapon = gamestate.chosenweapon = wp_stengun;   
        
	DrawAmmo();
	DrawWeapon();
	
}

/*
=======================
=
= ControlMovement
=
= Takes controlx,controly, and buttonstate[bt_strafe]
=
= Changes the player's angle and position
=
= There is an angle hack because when going 70 fps, the roundoff becomes
= significant
=
=======================
*/

void ControlMovement (objtype *ob)
{
    int32_t oldx,oldy;
    int     angle;
    int     angleunits;

    thrustspeed = 0;

    oldx = player->x;
    oldy = player->y;

    if(buttonstate[bt_strafeleft])
    {
        angle = ob->angle + ANGLES/4;
        if(angle >= ANGLES)
            angle -= ANGLES;
        if(buttonstate[bt_run])
            Thrust(angle, RUNMOVE * MOVESCALE * tics);
        else
            Thrust(angle, BASEMOVE * MOVESCALE * tics);
    }

    if(buttonstate[bt_straferight])
    {
        angle = ob->angle - ANGLES/4;
        if(angle < 0)
            angle += ANGLES;
        if(buttonstate[bt_run])
            Thrust(angle, RUNMOVE * MOVESCALE * tics );
        else
            Thrust(angle, BASEMOVE * MOVESCALE * tics);
    }

    //
    // side to side move
    //
    if (buttonstate[bt_strafe])
    {
        //
        // strafing
        //
        //
        if (controlx > 0)
        {
            angle = ob->angle - ANGLES/4;
            if (angle < 0)
                angle += ANGLES;
            Thrust (angle,controlx*MOVESCALE);      // move to left
        }
        else if (controlx < 0)
        {
            angle = ob->angle + ANGLES/4;
            if (angle >= ANGLES)
                angle -= ANGLES;
            Thrust (angle,-controlx*MOVESCALE);     // move to right
        }
    }
    else
    {
        //
        // not strafing
        //
        anglefrac += controlx;
        angleunits = anglefrac/ANGLESCALE;
        anglefrac -= angleunits*ANGLESCALE;
        ob->angle -= angleunits;

        if (ob->angle >= ANGLES)
            ob->angle -= ANGLES;
        if (ob->angle < 0)
            ob->angle += ANGLES;

    }

    //
    // forward/backwards move
    //
    if (controly < 0)
    {
        Thrust (ob->angle,-controly*MOVESCALE); // move forwards
    }
    else if (controly > 0)
    {
        angle = ob->angle + ANGLES/2;
        if (angle >= ANGLES)
            angle -= ANGLES;
        Thrust (angle,controly*BACKMOVESCALE);          // move backwards
    }

    if (gamestate.victoryflag)              // watching the BJ actor
        return;
}

/*
=============================================================================

                            STATUS WINDOW STUFF

=============================================================================
*/


/*
==================
=
= StatusDrawPic
=
==================
*/

void StatusDrawPic (unsigned x, unsigned y, unsigned picnum)
{
    LatchDrawPicScaledCoord ((screenWidth-scaleFactor*320)/16 + scaleFactor*x,
        screenHeight-scaleFactor*(STATUSLINES-y),picnum);
}

void StatusDrawPic2 (unsigned x, unsigned y, unsigned picnum) // Adjust score for 10,000,000+ 
{ 
    LatchDrawPicScaledCoord ((screenWidth-scaleFactor*320)/16 + scaleFactor*x+1, 
        screenHeight-scaleFactor*(STATUSLINES-y),picnum); 
} 

void StatusDrawFace(unsigned picnum)
{
    StatusDrawPic(17, 4, picnum);

#ifdef _arch_dreamcast
    DC_StatusDrawLCD(picnum);
#endif
}


/*
==================
=
= DrawFace
=
==================
*/

void DrawFace (void)
{
    if(viewsize == 21 && ingame) return;
    if (SD_SoundPlaying() == GETGATLINGSND)
        StatusDrawFace(GOTGATLINGPIC);
    else if (gamestate.health)
    {
        if (godmode)
            StatusDrawFace(MUTANTBJPIC);
        else if (gamestate.health>100)
	    	StatusDrawFace (FACE1APIC+gamestate.faceframe);    
        else
            StatusDrawFace(FACE1APIC+3*((100-gamestate.health)/16)+gamestate.faceframe);
    }
    else
    {
#ifndef SPEAR
        if (LastAttacker && LastAttacker->obclass == needleobj)
            StatusDrawFace(MUTANTBJPIC);
        else
#endif
            StatusDrawFace(FACE8APIC);
    }
}


/*
===============
=
= UpdateFace
=
= Calls draw face if time to change
=
===============
*/

int facecount = 0;
int facetimes = 0;

void UpdateFace (void)
{
    // don't make demo depend on sound playback
    if(demoplayback || demorecord)
    {
        if(facetimes > 0)
        {
            facetimes--;
            return;
        }
    }
    else if(SD_SoundPlaying() == GETGATLINGSND)
        return;

    facecount += tics;
    if (facecount > US_RndT())
    {
        gamestate.faceframe = (US_RndT()>>6);
        if (gamestate.faceframe==3)
            gamestate.faceframe = 1;

        facecount = 0;
        DrawFace ();
    }
}



/*
===============
=
= LatchNumber
=
= right justifies and pads with blanks
=
===============
*/

static void LatchNumber (int x, int y, unsigned width, int32_t number)
{
    unsigned length,c;
    char    str[20];

    ltoa (number,str,10);

    length = (unsigned) strlen (str);

    while (length<width)
    {
        StatusDrawPic (x,y,N_BLANKPIC);
        x++;
        width--;
    }

    c = length <= width ? 0 : length-width;

    while (c<length)
    {
        StatusDrawPic (x,y,str[c]-'0'+ N_0PIC);
        x++;
        c++;
    }
}


/* 
=============== 
= 
= LatchNumber2     // Adjusts score alignment when it goes over a million 
= 
= right justifies and pads with blanks 
= 
=============== 
*/ 

static void LatchNumber2 (int x, int y, unsigned width, int32_t number) 
{ 
    unsigned length,c; 
    char    str[20]; 

    ltoa (number,str,10); 

    length = (unsigned) strlen (str); 

    while (length<width) 
    { 
        StatusDrawPic2 (x,y,N_BLANKPIC); 
        x++; 
        width--; 
    } 

    c = length <= width ? 0 : length-width; 

    while (c<length) 
    { 
        StatusDrawPic2 (x,y,str[c]-'0'+ N_0PIC); 
        x++; 
        c++; 
    } 
} 


/*
===============
=
= DrawHealth
=
===============
*/

void DrawHealth (void)
{
    if(viewsize == 21 && ingame) return;
    LatchNumber (21,16,3,gamestate.health);
}


/*
===============
=
= TakeDamage
=
===============
*/

void TakeDamage (int points,objtype *attacker)
{
    LastAttacker = attacker;

    if (gamestate.victoryflag)
        return;
    if (gamestate.difficulty==gd_baby)
        points>>=2;

    if (!godmode)
        gamestate.health -= points;

    if (gamestate.health<=0)
    {
        gamestate.health = 0;
        playstate = ex_died;
        killerobj = attacker;
    }

    if (godmode != 2)
        StartDamageFlash (points);

    DrawHealth ();
    DrawFace ();

    //
    // MAKE BJ'S EYES BUG IF MAJOR DAMAGE!
    //
#ifdef SPEAR
    if (points > 30 && gamestate.health!=0 && !godmode && viewsize != 21)
    {
        StatusDrawFace(BJOUCHPIC);
        facecount = 0;
    }
#endif
}

/*
===============
=
= HealSelf
=
===============
*/

void HealSelf (int points)
{
    gamestate.health += points;
    if (gamestate.health>200)
        gamestate.health = 200;

    DrawHealth ();
    DrawFace ();
}


//===========================================================================


/*
===============
=
= DrawLevel
=
===============
*/

void DrawLevel (void)
{
    if(viewsize == 21 && ingame) return;
#ifdef SPEAR
    if (gamestate.mapon == 20)
        LatchNumber (2,16,2,18);
    else
#endif
        LatchNumber (2,16,2,gamestate.mapon+1);
}

//===========================================================================


/*
===============
=
= DrawLives
=
===============
*/

void DrawLives (void)
{
    if(viewsize == 21 && ingame) return;
    LatchNumber (14,16,2,gamestate.lives);
}


/*
===============
=
= GiveExtraMan
=
===============
*/

void GiveExtraMan (void)
{
    if (gamestate.lives<50)
        gamestate.lives++;
    DrawLives ();
    SD_PlaySound (BONUS1UPSND);
}

//===========================================================================

/*
===============
=
= DrawScore
=
===============
*/

void DrawScore (void) 
{ 
    if(viewsize == 21 && ingame) return; 

    if (gamestate.score >= 10000000) 
    { 
//        gamestate.score = -gamestate.score;     // temp marker 
        LatchNumber (5,16,8,gamestate.score); 
//        gamestate.score = -gamestate.score; 
    } 
    else 
    { 
/*       if (gamestate.score == gamestate.oldscore)   // clear score area 
       { 
           gamestate.score = -(gamestate.score+1); 
           LatchNumber (5,16,8,1); 
           gamestate.score = -(gamestate.score+1); 
       } */
       LatchNumber (5,16,7,gamestate.score); 
    } 
}

/*
===============
=
= ResetScore
=
===============
*/

/*
void ResetScore (void)
{
    if(viewsize == 21 && ingame) return;

        LatchNumber2 (5,16,88,0);
}
*/


/*
===============
=
= GivePoints
=
===============
*/

void GivePoints (int32_t points)
{
    gamestate.score += points;
    while (gamestate.score >= gamestate.nextextra)
    {
        gamestate.nextextra += EXTRAPOINTS;
        GiveExtraMan ();
    }
    DrawScore ();
}

//===========================================================================

/*
==================
=
= DrawWeapon
=
==================
*/

void DrawWeapon (void)
{ 
if (gamestate.chosenweapon == wp_rifle1) 
{ 
	StatusDrawPic (32,8,RIFLE1PIC); 
} 
else if (gamestate.chosenweapon == wp_rifle2) 
{ 
	StatusDrawPic (32,8,RIFLE2PIC); 
}
else if (gamestate.chosenweapon == wp_mlauncher) 
{
	StatusDrawPic (32,8,MLAUNCHERPIC);
}
else if (gamestate.chosenweapon == wp_ft) 
{
	StatusDrawPic (32,8,FTPIC);
}
else if (gamestate.chosenweapon == wp_lightning) 
{
	StatusDrawPic (32,8,LIGHTNINGPIC);
}
else if (gamestate.chosenweapon == wp_stengun) 
{
	StatusDrawPic (32,8,STENPIC);
}
else if (gamestate.chosenweapon == wp_pistol) 
{
	StatusDrawPic (32,8,GUNPIC);
}
else if (gamestate.chosenweapon == wp_machinegun) 
{
	StatusDrawPic (32,8,MACHINEGUNPIC);
}
else if (gamestate.chosenweapon == wp_chaingun) 
{
	StatusDrawPic (32,8,GATLINGGUNPIC);
}
else if (gamestate.chosenweapon == wp_knife) 
{
	StatusDrawPic (32,8,KNIFEPIC);
}
}

/*
==================
=
= DrawKeys
=
==================
*/

void DrawKeys (void)
{
    if(viewsize == 21 && ingame) return; 
	if (gamestate.keys & 1)
		StatusDrawPic (30,4,GOLDKEYPIC);
	else
		StatusDrawPic (30,4,NOKEYPIC);

	if (gamestate.keys & 2)
		StatusDrawPic (30,20,SILVERKEYPIC);
	else
		StatusDrawPic (30,20,NOKEYPIC);

	if (gamestate.keys & 4)
		StatusDrawPic (38,4,RUSTYKEYPIC);
	else
		StatusDrawPic (38,4,NOKEYPIC);

	if (gamestate.keys & 8)
		StatusDrawPic (38,20,IRONKEYPIC);
	else
		StatusDrawPic (38,20,NOKEYPIC);
}


/*
==================
=
= GiveWeapon
=
==================
*/

void GiveWeapon (int weapon)
{
	if (weapon != wp_mlauncher && weapon != wp_ft && weapon != wp_lightning) {
	switch (weapon) {
	    case wp_machinegun: GiveAmmo (6); gamestate.gotmachinegun = -1; break;
	    case wp_rifle1: GiveAmmo (8); gamestate.gotrifle1 = -1; break;
	    case wp_rifle2: GiveAmmo (10); gamestate.gotrifle2 = -1; break;
	    case wp_stengun: GiveAmmo (12); gamestate.gotstengun = -1; break;
	    case wp_chaingun: GiveAmmo (14); break;
	}
    }
    else if (weapon == wp_mlauncher)
        { 
		gamestate.weapon = gamestate.chosenweapon = (weapontype) weapon;
		if (!gotmlauncher) {
			extraammo = 1;
		}
		gotmlauncher = -1;
		GiveMissile (2);
		return;
	}
    else if (weapon == wp_ft)
	{
		gamestate.weapon = gamestate.chosenweapon = (weapontype) weapon;
		if (!gotflamethrower) {
			eextraammo = 1;
		}
		gotflamethrower = -1;
		GiveOil (5);
		return;
	}
    else if (weapon == wp_lightning)
	{
		gamestate.weapon = gamestate.chosenweapon = (weapontype) weapon;
		if (!gotlightning) {
			eeextraammo = 1;
		}
		gotlightning = -1;
		GiveBatteries (10);
		return;
	}
	if (gamestate.bestweapon<weapon)
		gamestate.bestweapon = gamestate.weapon
		= gamestate.chosenweapon = (weapontype) weapon;
		
    DrawWeapon ();	
}

//===========================================================================

/*
===============
=
= DrawAmmo
=
===============
*/

void DrawAmmo (void)
{
    switch (gamestate.chosenweapon)
    {
		case wp_lightning:
           LatchNumber (27,16,3,gamestate.batteries);
           break;
        case wp_ft:
           LatchNumber (27,16,3,gamestate.oil);
           break; 
        case wp_mlauncher:
           LatchNumber (27,16,3,gamestate.missile);
           break;    
        case wp_knife: 
           LatchNumber (27,16,3,0);
           break;
        default:
           LatchNumber (27,16,3,gamestate.ammo); 
       }
}

/*
===============
=
= GiveAmmo
=
===============
*/

void	GiveAmmo (int ammo)
{
	if (!gamestate.ammo)				// knife was out
	{
		if (!gamestate.attackframe)
		{
			gamestate.weapon = gamestate.chosenweapon;
			DrawWeapon ();
		}
	}
	gamestate.ammo += ammo;
	if (gamestate.ammo > 300)
		gamestate.ammo = 300;
	DrawAmmo ();
}

/*
==================
=
= GiveMissile
=
==================
*/

void	GiveMissile (int missile)
{
	gamestate.missile += missile;
	if (gamestate.missile > 20)
		gamestate.missile = 20;

	DrawAmmo ();
}

/*
==================
=
= GiveOil
=
==================
*/

void	GiveOil (int oil)
{
	gamestate.oil += oil;
	if (gamestate.oil > 150)
		gamestate.oil = 150;

	DrawAmmo ();
}

/*
==================
=
= GiveBatteries
=
==================
*/

void	GiveBatteries (int batteries)
{
	gamestate.batteries += batteries;
	if (gamestate.batteries > 250)
		gamestate.batteries = 250;

	DrawAmmo ();
}

//===========================================================================

/*
==================
=
= GiveKey
=
==================
*/

void GiveKey (int key)
{
    gamestate.keys |= (1<<key);
    DrawKeys ();
}



/*
=============================================================================

                                MOVEMENT

=============================================================================
*/


/*
===================
=
= GetBonus
=
===================
*/
void GetBonus (statobj_t *check)
{
    switch (check->itemnumber)
    {
        case    bo_firstaid:
            if (gamestate.health == 200)
                return;

            SD_PlaySound (HEALTH2SND);
            HealSelf (25);
            break;

        case    bo_key1:
        case    bo_key2:
        case    bo_key3:
        case    bo_key4:
            GiveKey (check->itemnumber - bo_key1);
            SD_PlaySound (GETKEYSND);
            break;

        case    bo_cross:
            SD_PlaySound (BONUS1SND);
            GivePoints (100);
            gamestate.treasurecount++;
            break;
        case    bo_chalice:
            SD_PlaySound (BONUS2SND);
            GivePoints (500);
            gamestate.treasurecount++;
            break;
        case    bo_bible:
            SD_PlaySound (BONUS3SND);
            GivePoints (1000);
            gamestate.treasurecount++;
            break;
        case    bo_crown:
            SD_PlaySound (BONUS4SND);
            GivePoints (5000);
            gamestate.treasurecount++;
            break;
	    case    bo_gold:
            SD_PlaySound (BONUS2SND);
            GivePoints (2500);
            gamestate.treasurecount++;
            break;
		case    bo_mastercrown:
            SD_PlaySound (BONUS4SND);
            GivePoints (7500);
            gamestate.treasurecount++;
            break;	    
        case	bo_godmode:
	       	 SD_PlaySound (GETLIGHTNINGSND); 
  		     GivePoints (10000);
  		     gamestate.treasurecount++; 
 	         godmode = 1;
  		     gamestate.godmode = true;
  		     gamestate.godmodecount++;
		     break;	

        case    bo_clip:
            if (gamestate.ammo == 300)
                return;

            SD_PlaySound (GETAMMOSND);
            GiveAmmo (8);
            break;
        case    bo_clip2:
            if (gamestate.ammo == 300)
                return;

            SD_PlaySound (GETAMMOSND);
            GiveAmmo (4);
            break;

        case	bo_rocket:
		    if (gamestate.missile == 20) 
                return;    

             SD_PlaySound (GETAMMOSND);
             GiveMissile (1);
             break;      

   	   case	   bo_kerosene:
		   if (gamestate.oil == 150) 
               return;    

            SD_PlaySound (GETAMMOSND);
            GiveOil (10);
            break; 

       case    bo_battery:
		   if (gamestate.batteries == 250)
               return;    

            SD_PlaySound (GETAMMOSND);
            GiveBatteries (20);
            break; 
		
		case    bo_25clip:
            if (gamestate.ammo == 300)
                return;

            SD_PlaySound (GETAMMOBOXSND);
            GiveAmmo (25);
            break;
		
	    case    bo_machinegun:
            SD_PlaySound (GETMACHINESND);
            GiveWeapon (wp_machinegun);
            break;
        case    bo_chaingun:
            SD_PlaySound (GETGATLINGSND);
            facetimes = 38;
            GiveWeapon (wp_chaingun);

            if(viewsize != 21)
                StatusDrawFace (GOTGATLINGPIC);
            facecount = 0;
            break;	
		
		case    bo_rifle1:
            SD_PlaySound (GETMACHINESND);
            GiveWeapon (wp_rifle1);
            break;
	
		case    bo_rifle2:
            SD_PlaySound (GETMACHINESND);
            GiveWeapon (wp_rifle2);
            break;
		
	    case    bo_fullheal:
            SD_PlaySound (BONUS1UPSND);
            HealSelf (99);
            GivePoints (10000);
            GiveAmmo (25);
            GiveExtraMan ();
            gamestate.treasurecount++;
            break;

        case    bo_food:
            if (gamestate.health == 200)
                return;

            SD_PlaySound (HEALTH1SND);
            HealSelf (10);
            break;	
 
    	case    bo_death:
	      	SD_PlaySound (TAKEDAMAGESND);
	     	gamestate.health = 0;
            playstate = ex_died;
            StatusDrawPic (17,4,FACE8APIC);
		    DrawHealth();
            break;

      	case	bo_mlauncher:
	      	SD_PlaySound (GETGATLINGSND);
	      	facetimes = 38;
	     	GiveWeapon (wp_mlauncher);

            if(viewsize != 21)
                StatusDrawFace (GOTGATLINGPIC);
	      	facecount = 0;
	     	break;

    	case	bo_fthrower:
	     	SD_PlaySound (GETGATLINGSND);
	     	facetimes = 38;
	    	GiveWeapon (wp_ft);

            if(viewsize != 21)
                StatusDrawFace (GOTGATLINGPIC);
	    	facecount = 0;
	    	break;

    	case	bo_lightning:
		    SD_PlaySound (GOTMLAUNCHERSND);
            facetimes = 38;
            GiveWeapon (wp_lightning);

            if(viewsize != 21)
                StatusDrawFace (GOTGATLINGPIC);
            facecount = 0;
            break;  

    	case	bo_stengun:
	      	SD_PlaySound (GETMACHINESND);
	     	GiveWeapon (wp_stengun);
	    	break;
		
        case    bo_alpo:
            if (gamestate.health == 200)
                return;

            SD_PlaySound (NAZIHITPLAYERSND);
            HealSelf (4);
            break;
					
	    case    bo_gibs:
            if (gamestate.health >20)
                return;

            SD_PlaySound (SLURPIESND);
            HealSelf (1);
            break;	

     	case	bo_needle:
	    	if (gamestate.health == 200)
		     	return;

	    	SD_PlaySound (HEALTH1SND);
	     	HealSelf (5);
	    	break;
					
     	case    bo_landmine:
	       	SD_PlaySound (BOOMSND); 
	    	TakeDamage (50,NULL);
	    	break;

//#ifdef SPEAR
        case    bo_spear:
            spearflag = true;
            spearx = player->x;
            speary = player->y;
            spearangle = player->angle;
            playstate = ex_completed;
//#endif

	}

	StartBonusFlash ();
	check->flags &= ~FL_BONUS;
	check->shapenum = -1;			// remove from list
}

/*
===================
=
= TryMove
=
= returns true if move ok
= debug: use pointers to optimize
===================
*/

boolean TryMove (objtype *ob)
{
    int         xl,yl,xh,yh,x,y;
    objtype    *check;
    int32_t     deltax,deltay;

    xl = (ob->x-PLAYERSIZE) >>TILESHIFT;
    yl = (ob->y-PLAYERSIZE) >>TILESHIFT;

    xh = (ob->x+PLAYERSIZE) >>TILESHIFT;
    yh = (ob->y+PLAYERSIZE) >>TILESHIFT;

#define PUSHWALLMINDIST PLAYERSIZE

    //
    // check for solid walls
    //
    for (y=yl;y<=yh;y++)
    {
        for (x=xl;x<=xh;x++)
        {
            check = actorat[x][y];
            if (check && !ISPOINTER(check))
            {
                if(tilemap[x][y]==64 && x==pwallx && y==pwally)   // back of moving pushwall?
                {
                    switch(pwalldir)
                    {
                        case di_north:
                            if(ob->y-PUSHWALLMINDIST<=(pwally<<TILESHIFT)+((63-pwallpos)<<10))
                                return false;
                            break;
                        case di_west:
                            if(ob->x-PUSHWALLMINDIST<=(pwallx<<TILESHIFT)+((63-pwallpos)<<10))
                                return false;
                            break;
                        case di_east:
                            if(ob->x+PUSHWALLMINDIST>=(pwallx<<TILESHIFT)+(pwallpos<<10))
                                return false;
                            break;
                        case di_south:
                            if(ob->y+PUSHWALLMINDIST>=(pwally<<TILESHIFT)+(pwallpos<<10))
                                return false;
                            break;
                    }
                }
                else return false;
            }
        }
    }

    //
    // check for actors
    //
    if (yl>0)
        yl--;
    if (yh<MAPSIZE-1)
        yh++;
    if (xl>0)
        xl--;
    if (xh<MAPSIZE-1)
        xh++;

    for (y=yl;y<=yh;y++)
    {
        for (x=xl;x<=xh;x++)
        {
            check = actorat[x][y];
            if (ISPOINTER(check) && check != player && (check->flags & FL_SHOOTABLE) )
            {
                deltax = ob->x - check->x;
                if (deltax < -MINACTORDIST || deltax > MINACTORDIST)
                    continue;
                deltay = ob->y - check->y;
                if (deltay < -MINACTORDIST || deltay > MINACTORDIST)
                    continue;

                return false;
            }
        }
    }

    return true;
}


/*
===================
=
= ClipMove
=
===================
*/

void ClipMove (objtype *ob, int32_t xmove, int32_t ymove)
{
    int32_t    basex,basey;

    basex = ob->x;
    basey = ob->y;

    ob->x = basex+xmove;
    ob->y = basey+ymove;
    if (TryMove (ob))
        return;

#ifndef REMDEBUG
    if (noclip && ob->x > 2*TILEGLOBAL && ob->y > 2*TILEGLOBAL
        && ob->x < (((int32_t)(mapwidth-1))<<TILESHIFT)
        && ob->y < (((int32_t)(mapheight-1))<<TILESHIFT) )
        return;         // walk through walls
#endif

#ifndef SLOWMO
    if (!SD_SoundPlaying() && !killwallsound) 
#else
    if (!SD_SoundPlaying())
#endif
        SD_PlaySound (HITWALLSND);

    ob->x = basex+xmove;
    ob->y = basey;
    if (TryMove (ob))
        return;

    ob->x = basex;
    ob->y = basey+ymove;
    if (TryMove (ob))
        return;

    ob->x = basex;
    ob->y = basey;
}

//==========================================================================

/*
===================
=
= VictoryTile
=
===================
*/

void VictoryTile (void)
{
//#ifndef SPEAR
//	SpawnBJVictory ();
//#endif

    gamestate.victoryflag = true;
}

/*
===================
=
= Thrust
=
===================
*/

// For player movement in demos exactly as in the original Wolf3D v1.4 source code
static fixed FixedByFracOrig(fixed a, fixed b)
{
    int sign = 0;
    if(b == 65536) b = 65535;
    else if(b == -65536) b = 65535, sign = 1;
    else if(b < 0) b = (-b), sign = 1;

    if(a < 0)
    {
        a = -a;
        sign = !sign;
    }
    fixed res = (fixed)(((int64_t) a * b) >> 16);
    if(sign)
        res = -res;
    return res;
}

void Thrust (int angle, int32_t speed)
{
    int32_t xmove,ymove;
    unsigned offset;
    
    if (gamestate.bobdir != 1) gamestate.bobber++; else gamestate.bobber--; 
    if (gamestate.bobber == 10 || gamestate.bobber == 0) gamestate.bobdir ^= 1; 
    if (gamestate.bobdir2 != 1) gamestate.bobber2++; else gamestate.bobber2--; 
    if (gamestate.bobber2 == 20 || gamestate.bobber2 == 0) gamestate.bobdir2 ^= 1; 


    //
    // ZERO FUNNY COUNTER IF MOVED!
    //
#ifdef SPEAR
    if (speed)
        funnyticount = 0;
#endif

    thrustspeed += speed;
    //
    // moving bounds speed
    //
    if (speed >= MINDIST*2)
        speed = MINDIST*2-1;

    xmove = DEMOCHOOSE_ORIG_SDL(
                FixedByFracOrig(speed, costable[angle]),
                FixedMul(speed,costable[angle]));
    ymove = DEMOCHOOSE_ORIG_SDL(
                -FixedByFracOrig(speed, sintable[angle]),
                -FixedMul(speed,sintable[angle]));

    ClipMove(player,xmove,ymove);

    player->tilex = (short)(player->x >> TILESHIFT);                // scale to tile values
    player->tiley = (short)(player->y >> TILESHIFT);

    offset = (player->tiley<<mapshift)+player->tilex;
    player->areanumber = *(mapsegs[0] + offset) -AREATILE;

    if (*(mapsegs[1] + offset) == EXITTILE)
        VictoryTile ();
   	if (*(mapsegs[1] + offset) == EXITLEVEL) 
      		playstate = ex_completed;   
}


/*
=============================================================================

                                ACTIONS

=============================================================================
*/


/*
===============
=
= Cmd_Fire
=
===============
*/

void Cmd_Fire (void)
{
    buttonheld[bt_attack] = true;

    gamestate.weaponframe = 0;

    player->state = &s_attack;

    gamestate.attackframe = 0;
    gamestate.attackcount =
        attackinfo[gamestate.weapon][gamestate.attackframe].tics;
    gamestate.weaponframe =
        attackinfo[gamestate.weapon][gamestate.attackframe].frame;
}

//===========================================================================

/*
===============
=
= Cmd_Use
=
===============
*/

void Cmd_Use (void)
{
    int     checkx,checky,doornum,dir;
    boolean elevatorok;

    //
    // find which cardinal direction the player is facing
    //
    if (player->angle < ANGLES/8 || player->angle > 7*ANGLES/8)
    {
        checkx = player->tilex + 1;
        checky = player->tiley;
        dir = di_east;
        elevatorok = true;
    }
    else if (player->angle < 3*ANGLES/8)
    {
        checkx = player->tilex;
        checky = player->tiley-1;
        dir = di_north;
        elevatorok = false;
    }
    else if (player->angle < 5*ANGLES/8)
    {
        checkx = player->tilex - 1;
        checky = player->tiley;
        dir = di_west;
        elevatorok = true;
    }
    else
    {
        checkx = player->tilex;
        checky = player->tiley + 1;
        dir = di_south;
        elevatorok = false;
    }

    doornum = tilemap[checkx][checky];
    if (*(mapsegs[1]+(checky<<mapshift)+checkx) == PUSHABLETILE)
    {
        //
        // pushable wall
        //

        PushWall (checkx,checky,dir);
        return;
    }
    if (!buttonheld[bt_use] && doornum == ELEVATORTILE && elevatorok)
    {
        //
        // use elevator
        //
        buttonheld[bt_use] = true;

        tilemap[checkx][checky]++;              // flip switch
        if (*(mapsegs[0]+(player->tiley<<mapshift)+player->tilex) == ALTELEVATORTILE)
            playstate = ex_secretlevel;
        else
            playstate = ex_completed;
        SD_PlaySound (LEVELDONESND);
        SD_WaitSoundDone();
    }
    else if (!buttonheld[bt_use] && doornum & BIT_DOOR)
    {
        buttonheld[bt_use] = true;
        OperateDoor (doornum & ~BIT_DOOR);
    }
#ifndef SLOWMO
    else if (!killwallsound)  
#else
    else
#endif
        SD_PlaySound (DONOTHINGSND);
}

/*
=============================================================================

                                PLAYER CONTROL

=============================================================================
*/



/*
===============
=
= SpawnPlayer
=
===============
*/

void SpawnPlayer (int tilex, int tiley, int dir)
{
    player->obclass = playerobj;
    player->active = ac_yes;
    player->tilex = tilex;
    player->tiley = tiley;
    player->areanumber = (byte) *(mapsegs[0]+(player->tiley<<mapshift)+player->tilex);
    player->x = ((int32_t)tilex<<TILESHIFT)+TILEGLOBAL/2;
    player->y = ((int32_t)tiley<<TILESHIFT)+TILEGLOBAL/2;
    player->state = &s_player;
    player->angle = (1-dir)*90;
    if (player->angle<0)
        player->angle += ANGLES;
    player->flags = FL_NEVERMARK;
    Thrust (0,0);                           // set some variables

    InitAreas ();
}


//===========================================================================

/*
===============
=
= FireAttack
=
===============
*/

void	FireAttack (objtype *ob)
{
   if (gamestate.oil<1) 
   { 
//       SD_PlaySound (DONOTHINGSND);                        
      return; 
   } 
   SD_PlaySound (FLAMETHROWERSND); 
   
   gamestate.oil--; 
   DrawAmmo (); 
   GetNewActor (); 

   newobj->state = &s_fire1; 
   newobj->ticcount = 1; 

   newobj->x = ob->x ; 
   newobj->y = ob->y ; 
   newobj->tilex = newobj->x >> TILESHIFT; 
   newobj->tiley = newobj->y >> TILESHIFT; 

   newobj->obclass = fireobj; 
   newobj->dir = nodir; 
   newobj->angle = ob->angle; 
   newobj->speed = 0x2000l; 
   newobj->flags = FL_NONMARK | FL_BONUS; 
   newobj->active = ac_yes; 
}

/*
===============
=
= BeamAttack
=
===============
*/

void	BeamAttack (objtype *ob)
{
   if (gamestate.batteries<1) 
   { 
      SD_PlaySound (ZAPSND);                        
      return; 
   } 
   SD_PlaySound (ZAPSND); 
   
   gamestate.batteries--; 
   DrawAmmo (); 
   GetNewActor (); 

   newobj->state = &s_beamobj1; 
   newobj->ticcount = 1; 

   newobj->x = ob->x ; 
   newobj->y = ob->y ; 
   newobj->tilex = newobj->x >> TILESHIFT; 
   newobj->tiley = newobj->y >> TILESHIFT; 

   newobj->obclass = beamobj; 
   newobj->dir = nodir; 
   newobj->angle = ob->angle; 
   newobj->speed = 0x2000l; 
   newobj->flags = FL_NONMARK | FL_BONUS; 
   newobj->active = ac_yes; 
}

/*
===============
=
= MissileAttack
=
===============
*/

void	MissileAttack(objtype *ob)
{ 
   if (gamestate.missile<1) 
   { 
//       SD_PlaySound (DONOTHINGSND);                            
      return; 
   } 
   SD_PlaySound (MISSILEFIRESND);
   
   gamestate.missile--; 
   DrawAmmo (); 
   GetNewActor (); 

   newobj->state = &s_rocket; 
   newobj->ticcount = 1; 

   newobj->x = ob->x ; 
   newobj->y = ob->y ; 
   newobj->tilex = newobj->x >> TILESHIFT; 
   newobj->tiley = newobj->y >> TILESHIFT; 

   newobj->obclass = rocketobj; 
   newobj->dir = nodir; 
   newobj->angle = ob->angle; 
   newobj->speed = 0x2000l; 
   newobj->flags = FL_NONMARK | FL_BONUS; 
   newobj->active = ac_yes; 
}

/*
===============
=
= T_KnifeAttack
=
= Update player hands, and try to do damage when the proper frame is reached
=
===============
*/

void    KnifeAttack (objtype *ob)
{
    objtype *check,*closest;
    int32_t  dist;

    SD_PlaySound (ATKKNIFESND);
    // actually fire
    dist = 0x7fffffff;
    closest = NULL;
    for (check=ob->next; check; check=check->next)
    {
        if ( (check->flags & FL_SHOOTABLE) && (check->flags & FL_VISABLE)
            && abs(check->viewx-centerx) < shootdelta)
        {
            if (check->transx < dist)
            {
                dist = check->transx;
                closest = check;
            }
        }
    }

    if (!closest || dist > 0x18000l)
    {
        // missed
        return;
    }

    // hit something
    DamageActor (closest,US_RndT() >> 4);
}



void    GunAttack (objtype *ob)
{
    objtype *check,*closest,*oldclosest;
    int      damage;
    int      dx,dy,dist;
    int32_t  viewdist;

	if (gamestate.weapon == wp_mlauncher)
	{
        madenoise = true;                   
		MissileAttack (ob);
		return;
	}
	else if (gamestate.weapon == wp_ft)
	{
        madenoise = true;   
		FireAttack (ob);
		return;
	}
	else if (gamestate.weapon == wp_lightning)
	{
        madenoise = true;   
		BeamAttack (ob);
		return;
	}

	switch (gamestate.weapon)
	{
	case wp_pistol:
		SD_PlaySound (ATKPISTOLSND);
		madenoise = true;
		break;
	case wp_machinegun:
		SD_PlaySound (ATKMACHINEGUNSND);
		madenoise = true;
		break;
	case wp_rifle1:
		SD_PlaySound (ATKRIFLE1SND);
		madenoise = true;
		break;
	case wp_rifle2:
		SD_PlaySound (ATKRIFLE2SND);
		madenoise = true;
		break;
	case wp_chaingun:
		SD_PlaySound (ATKGATLINGSND);
		madenoise = true;
		break;
	case wp_stengun:
		SD_PlaySound (ATKSTENSND);
		break;
	}

//	madenoise = true;

    //
    // find potential targets
    //
    viewdist = 0x7fffffffl;
    closest = NULL;

    while (1)
    {
        oldclosest = closest;

        for (check=ob->next ; check ; check=check->next)
        {
            if ((check->flags & FL_SHOOTABLE) && (check->flags & FL_VISABLE)
                && abs(check->viewx-centerx) < shootdelta)
            {
                if (check->transx < viewdist)
                {
                    viewdist = check->transx;
                    closest = check;
                }
            }
        }

        if (closest == oldclosest)
            return;                                         // no more targets, all missed

        //
        // trace a line from player to enemey
        //
        if (CheckLine(closest))
            break;
    }

    //
    // hit something
    //
    dx = ABS(closest->tilex - player->tilex);
    dy = ABS(closest->tiley - player->tiley);
    dist = dx>dy ? dx:dy;
    if (dist<2)
        damage = US_RndT() / 4;
    else if (dist<4)
        damage = US_RndT() / 6;
    else
    {
        if ( (US_RndT() / 12) < dist)           // missed
            return;
        damage = US_RndT() / 6;
    }
    DamageActor (closest,damage);
}

//===========================================================================

/*
===============
=
= VictorySpin
=
===============
*/

void VictorySpin (void)
{
    int32_t    desty;

    if (player->angle > 270)
    {
        player->angle -= (short)(tics * 3);
        if (player->angle < 270)
            player->angle = 270;
    }
    else if (player->angle < 270)
    {
        player->angle += (short)(tics * 3);
        if (player->angle > 270)
            player->angle = 270;
    }

    desty = (((int32_t)player->tiley-5)<<TILESHIFT)-0x3000;

    if (player->y > desty)
    {
        player->y -= tics*4096;
        if (player->y < desty)
            player->y = desty;
    }
}


//===========================================================================

/*
===============
=
= T_Attack
=
===============
*/

void    T_Attack (objtype *ob)
{
    struct  atkinf  *cur;

    UpdateFace ();

    if (gamestate.victoryflag)              // watching the BJ actor
    {
        VictorySpin ();
        return;
    }

    if ( buttonstate[bt_use] && !buttonheld[bt_use] )
        buttonstate[bt_use] = false;

    if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
        buttonstate[bt_attack] = false;

    ControlMovement (ob);
    if (gamestate.victoryflag)              // watching the BJ actor
        return;

    plux = (word) (player->x >> UNSIGNEDSHIFT);                     // scale to fit in unsigned
    pluy = (word) (player->y >> UNSIGNEDSHIFT);
    player->tilex = (short)(player->x >> TILESHIFT);                // scale to tile values
    player->tiley = (short)(player->y >> TILESHIFT);

    //
    // change frame and fire
    //
    gamestate.attackcount -= (short) tics;
    while (gamestate.attackcount <= 0)
    {
        cur = &attackinfo[gamestate.weapon][gamestate.attackframe];
        switch (cur->attack)
        {
            case -1:
                ob->state = &s_player;
                if (!ChkAtkAmmo(gamestate.weapon))
                {
                    gamestate.weapon = gamestate.chosenweapon = wp_knife;
                    DrawWeapon ();
                }
                else
                {
                //   if (gamestate.weapon != gamestate.chosenweapon)
                //   {
                        gamestate.weapon = gamestate.chosenweapon;
                        DrawWeapon ();
                 //   }
                }
                gamestate.attackframe = gamestate.weaponframe = 0;
                return;

            case 4:
                if (!ChkAtkAmmo(gamestate.weapon))
                    break;
                if (buttonstate[bt_attack])
                    gamestate.attackframe -= 2;
            case 1:
                if (!ChkAtkAmmo(gamestate.weapon) && gamestate.weapon < wp_stengun)
                {       // can only happen with chain gun
                    gamestate.attackframe++;
                    break;
                }

					if (!ammocheat)     
					{
                        GunAttack (ob);  
                        }         
						switch (gamestate.weapon)
						{
						case wp_pistol:
                        case wp_machinegun:
                        case wp_rifle1:
                        case wp_rifle2:
                        case wp_chaingun:
                        case wp_stengun:
							gamestate.ammo--;
							break;
					}				
					DrawAmmo ();
					break;

            case 2:
                KnifeAttack (ob);
                break;

            case 3:
                if (ChkAtkAmmo(gamestate.weapon) && buttonstate[bt_attack])
                    gamestate.attackframe -= 2;
                break;
        }

        gamestate.attackcount += cur->tics;
        gamestate.attackframe++;
        gamestate.weaponframe =
            attackinfo[gamestate.weapon][gamestate.attackframe].frame;
    }
}



//===========================================================================

/*
===============
=
= T_Player
=
===============
*/

void    T_Player (objtype *ob)
{
    if (gamestate.victoryflag)              // watching the BJ actor
    {
        VictorySpin ();
        return;
    }

    UpdateFace ();
    CheckWeaponChange ();

    if ( buttonstate[bt_use] )
        Cmd_Use ();

    if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
        Cmd_Fire ();

    ControlMovement (ob);
    if (gamestate.victoryflag)              // watching the BJ actor
        return;

    plux = (word) (player->x >> UNSIGNEDSHIFT);                     // scale to fit in unsigned
    pluy = (word) (player->y >> UNSIGNEDSHIFT);
    player->tilex = (short)(player->x >> TILESHIFT);                // scale to tile values
    player->tiley = (short)(player->y >> TILESHIFT);
}
